window.Gleam.initSearch([{"doc":"webmidi","title":"webmidi","content":"# webmidi\n\n[![Package Version](https://img.shields.io/hexpm/v/webmidi)](https://hex.pm/packages/webmidi)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/webmidi/)\n\nGleam bindings to the Web MIDI API.\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add webmidi\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/webmidi&gt;.\n","url":"index.html"},{"doc":"webmidi","title":"ConnectionEvent","content":"pub type ConnectionEvent\n\n\nSynonyms:\nwebmidi.ConnectionEvent\nwebmidi ConnectionEvent","url":"webmidi.html#ConnectionEvent"},{"doc":"webmidi","title":"MessageEvent","content":"pub type MessageEvent\n\n\nSynonyms:\nwebmidi.MessageEvent\nwebmidi MessageEvent","url":"webmidi.html#MessageEvent"},{"doc":"webmidi","title":"MidiAccess","content":"pub type MidiAccess\n\n\nSynonyms:\nwebmidi.MidiAccess\nwebmidi MidiAccess","url":"webmidi.html#MidiAccess"},{"doc":"webmidi","title":"MidiData","content":"pub type MidiData {\n  NoteOff(channel: Int, pitch: Int, velocity: Int)\n  NoteOn(channel: Int, pitch: Int, velocity: Int)\n  PolyPressure(channel: Int, pitch: Int, pressure: Int)\n  BankSelect(channel: Int, value: Int)\n  Modulation(channel: Int, value: Int)\n  BreathController(channel: Int, value: Int)\n  Undefined1(channel: Int, value: Int)\n  FootController(channel: Int, value: Int)\n  PortamentoTime(channel: Int, value: Int)\n  ChannelVolume(channel: Int, value: Int)\n  Balance(channel: Int, value: Int)\n  Undefined2(channel: Int, value: Int)\n  Pan(channel: Int, value: Int)\n  ExpressionController(channel: Int, value: Int)\n  SongSelect(id: Int)\n  TuneRequest\n  EndOfSysEx\n  Timing\n  Start\n  Continue\n  Stop\n  ActiveSensing\n  SystemReset\n  Undefined(value: Int)\n  Err(value: BitArray)\n}\n\nNoteOff(channel: Int, pitch: Int, velocity: Int)\n\n\nNoteOn(channel: Int, pitch: Int, velocity: Int)\n\n\nPolyPressure(channel: Int, pitch: Int, pressure: Int)\n\n\nBankSelect(channel: Int, value: Int)\n\n\nModulation(channel: Int, value: Int)\n\n\nBreathController(channel: Int, value: Int)\n\n\nUndefined1(channel: Int, value: Int)\n\n\nFootController(channel: Int, value: Int)\n\n\nPortamentoTime(channel: Int, value: Int)\n\n\nChannelVolume(channel: Int, value: Int)\n\n\nBalance(channel: Int, value: Int)\n\n\nUndefined2(channel: Int, value: Int)\n\n\nPan(channel: Int, value: Int)\n\n\nExpressionController(channel: Int, value: Int)\n\n\nSongSelect(id: Int)\n\n\nTuneRequest\n\n\nEndOfSysEx\n\n\nTiming\n\n\nStart\n\n\nContinue\n\n\nStop\n\n\nActiveSensing\n\n\nSystemReset\n\n\nUndefined(value: Int)\n\n\nErr(value: BitArray)\n\n\nSynonyms:\nwebmidi.MidiData\nwebmidi MidiData","url":"webmidi.html#MidiData"},{"doc":"webmidi","title":"MidiInput","content":"pub type MidiInput\n\n\nSynonyms:\nwebmidi.MidiInput\nwebmidi MidiInput","url":"webmidi.html#MidiInput"},{"doc":"webmidi","title":"MidiInputMap","content":"pub type MidiInputMap\n A MIDIInputMap instance is a read-only Map-like object, in which each key is the ID \n string for MIDI input, and the associated value is the corresponding MIDIInput object.\n\nSynonyms:\nwebmidi.MidiInputMap\nwebmidi MidiInputMap","url":"webmidi.html#MidiInputMap"},{"doc":"webmidi","title":"MidiOutput","content":"pub type MidiOutput\n\n\nSynonyms:\nwebmidi.MidiOutput\nwebmidi MidiOutput","url":"webmidi.html#MidiOutput"},{"doc":"webmidi","title":"MidiOutputMap","content":"pub type MidiOutputMap\n A MIDIOutputMap instance is a read-only Map-like object, in which each key is the ID \n\nSynonyms:\nwebmidi.MidiOutputMap\nwebmidi MidiOutputMap","url":"webmidi.html#MidiOutputMap"},{"doc":"webmidi","title":"MidiPort","content":"pub type MidiPort\n\n\nSynonyms:\nwebmidi.MidiPort\nwebmidi MidiPort","url":"webmidi.html#MidiPort"},{"doc":"webmidi","title":"request_midi","content":"pub fn request_midi() -&gt; Promise(MidiAccess)\n\nSynonyms:\nwebmidi.request_midi\nwebmidi request_midi","url":"webmidi.html#request_midi"},{"doc":"webmidi","title":"to_data","content":"pub fn to_data(raw: BitArray) -&gt; MidiData\n\nSynonyms:\nwebmidi.to_data\nwebmidi to_data","url":"webmidi.html#to_data"},{"doc":"webmidi","title":"webmidi","content":"","url":"webmidi.html"},{"doc":"webmidi/access","title":"inputs","content":"pub fn inputs(access: MidiAccess) -&gt; MidiInputMap\n\nSynonyms:\nwebmidi/access.inputs\nwebmidi/access inputs","url":"webmidi/access.html#inputs"},{"doc":"webmidi/access","title":"on_state_change","content":"pub fn on_state_change(\n  access: MidiAccess,\n  func: fn(ConnectionEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nwebmidi/access.on_state_change\nwebmidi/access on_state_change","url":"webmidi/access.html#on_state_change"},{"doc":"webmidi/access","title":"outputs","content":"pub fn outputs(access: MidiAccess) -&gt; MidiOutputMap\n\nSynonyms:\nwebmidi/access.outputs\nwebmidi/access outputs","url":"webmidi/access.html#outputs"},{"doc":"webmidi/access","title":"sysex_enabled","content":"pub fn sysex_enabled(access: MidiAccess) -&gt; Bool\n\nSynonyms:\nwebmidi/access.sysex_enabled\nwebmidi/access sysex_enabled","url":"webmidi/access.html#sysex_enabled"},{"doc":"webmidi/access","title":"webmidi/access","content":"","url":"webmidi/access.html"},{"doc":"webmidi/event","title":"connection_port","content":"pub fn connection_port(event: ConnectionEvent) -&gt; MidiPort\n\nSynonyms:\nwebmidi/event.connection_port\nwebmidi/event connection_port","url":"webmidi/event.html#connection_port"},{"doc":"webmidi/event","title":"message_data","content":"pub fn message_data(event: MessageEvent) -&gt; BitArray\n\nSynonyms:\nwebmidi/event.message_data\nwebmidi/event message_data","url":"webmidi/event.html#message_data"},{"doc":"webmidi/event","title":"webmidi/event","content":"","url":"webmidi/event.html"},{"doc":"webmidi/port","title":"Connection","content":"pub type Connection {\n  Open\n  Closed\n  Pending\n}\n\nOpen\n\n\nClosed\n\n\nPending\n\n\nSynonyms:\nwebmidi/port.Connection\nwebmidi/port Connection","url":"webmidi/port.html#Connection"},{"doc":"webmidi/port","title":"State","content":"pub type State {\n  Disconnected\n  Connected\n}\n\nDisconnected\n\n\nConnected\n\n\nSynonyms:\nwebmidi/port.State\nwebmidi/port State","url":"webmidi/port.html#State"},{"doc":"webmidi/port","title":"Type","content":"pub type Type {\n  Input\n  Output\n}\n\nInput\n\n\nOutput\n\n\nSynonyms:\nwebmidi/port.Type\nwebmidi/port Type","url":"webmidi/port.html#Type"},{"doc":"webmidi/port","title":"closed","content":"pub fn closed(port: MidiPort) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/port.closed\nwebmidi/port closed","url":"webmidi/port.html#closed"},{"doc":"webmidi/port","title":"connection","content":"pub fn connection(port: MidiPort) -&gt; Connection\n\nSynonyms:\nwebmidi/port.connection\nwebmidi/port connection","url":"webmidi/port.html#connection"},{"doc":"webmidi/port","title":"id","content":"pub fn id(port: MidiPort) -&gt; String\n\nSynonyms:\nwebmidi/port.id\nwebmidi/port id","url":"webmidi/port.html#id"},{"doc":"webmidi/port","title":"manufacturer","content":"pub fn manufacturer(port: MidiPort) -&gt; String\n\nSynonyms:\nwebmidi/port.manufacturer\nwebmidi/port manufacturer","url":"webmidi/port.html#manufacturer"},{"doc":"webmidi/port","title":"name","content":"pub fn name(port: MidiPort) -&gt; String\n\nSynonyms:\nwebmidi/port.name\nwebmidi/port name","url":"webmidi/port.html#name"},{"doc":"webmidi/port","title":"on_state_change","content":"pub fn on_state_change(\n  port: MidiPort,\n  func: fn(ConnectionEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nwebmidi/port.on_state_change\nwebmidi/port on_state_change","url":"webmidi/port.html#on_state_change"},{"doc":"webmidi/port","title":"open","content":"pub fn open(port: MidiPort) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/port.open\nwebmidi/port open","url":"webmidi/port.html#open"},{"doc":"webmidi/port","title":"state","content":"pub fn state(port: MidiPort) -&gt; State\n\nSynonyms:\nwebmidi/port.state\nwebmidi/port state","url":"webmidi/port.html#state"},{"doc":"webmidi/port","title":"type_","content":"pub fn type_(port: MidiPort) -&gt; Type\n\nSynonyms:\nwebmidi/port.type_\nwebmidi/port type_","url":"webmidi/port.html#type_"},{"doc":"webmidi/port","title":"version","content":"pub fn version(port: MidiPort) -&gt; String\n\nSynonyms:\nwebmidi/port.version\nwebmidi/port version","url":"webmidi/port.html#version"},{"doc":"webmidi/port","title":"webmidi/port","content":"","url":"webmidi/port.html"},{"doc":"webmidi/input","title":"closed","content":"pub fn closed(port: MidiInput) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/input.closed\nwebmidi/input closed","url":"webmidi/input.html#closed"},{"doc":"webmidi/input","title":"connection","content":"pub fn connection(port: MidiInput) -&gt; Connection\n\nSynonyms:\nwebmidi/input.connection\nwebmidi/input connection","url":"webmidi/input.html#connection"},{"doc":"webmidi/input","title":"id","content":"pub fn id(port: MidiInput) -&gt; String\n\nSynonyms:\nwebmidi/input.id\nwebmidi/input id","url":"webmidi/input.html#id"},{"doc":"webmidi/input","title":"manufacturer","content":"pub fn manufacturer(port: MidiInput) -&gt; String\n\nSynonyms:\nwebmidi/input.manufacturer\nwebmidi/input manufacturer","url":"webmidi/input.html#manufacturer"},{"doc":"webmidi/input","title":"name","content":"pub fn name(port: MidiInput) -&gt; String\n\nSynonyms:\nwebmidi/input.name\nwebmidi/input name","url":"webmidi/input.html#name"},{"doc":"webmidi/input","title":"on_midi_message","content":"pub fn on_midi_message(\n  input: MidiInput,\n  func func: fn(MessageEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nwebmidi/input.on_midi_message\nwebmidi/input on_midi_message","url":"webmidi/input.html#on_midi_message"},{"doc":"webmidi/input","title":"on_state_change","content":"pub fn on_state_change(\n  port: MidiInput,\n  func: fn(ConnectionEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nwebmidi/input.on_state_change\nwebmidi/input on_state_change","url":"webmidi/input.html#on_state_change"},{"doc":"webmidi/input","title":"open","content":"pub fn open(port: MidiInput) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/input.open\nwebmidi/input open","url":"webmidi/input.html#open"},{"doc":"webmidi/input","title":"state","content":"pub fn state(port: MidiInput) -&gt; State\n\nSynonyms:\nwebmidi/input.state\nwebmidi/input state","url":"webmidi/input.html#state"},{"doc":"webmidi/input","title":"type_","content":"pub fn type_(port: MidiInput) -&gt; Type\n\nSynonyms:\nwebmidi/input.type_\nwebmidi/input type_","url":"webmidi/input.html#type_"},{"doc":"webmidi/input","title":"version","content":"pub fn version(port: MidiInput) -&gt; String\n\nSynonyms:\nwebmidi/input.version\nwebmidi/input version","url":"webmidi/input.html#version"},{"doc":"webmidi/input","title":"webmidi/input","content":"","url":"webmidi/input.html"},{"doc":"webmidi/input_map","title":"get","content":"pub fn get(\n  input_map: MidiInputMap,\n  key key: String,\n) -&gt; Result(MidiInput, Nil)\n\nSynonyms:\nwebmidi/input_map.get\nwebmidi/input_map get","url":"webmidi/input_map.html#get"},{"doc":"webmidi/input_map","title":"has","content":"pub fn has(input_map: MidiInputMap, key key: String) -&gt; Bool\n\nSynonyms:\nwebmidi/input_map.has\nwebmidi/input_map has","url":"webmidi/input_map.html#has"},{"doc":"webmidi/input_map","title":"map","content":"pub fn map(\n  input_map: MidiInputMap,\n  with fun: fn(String, MidiInput) -&gt; a,\n) -&gt; a\n\nSynonyms:\nwebmidi/input_map.map\nwebmidi/input_map map","url":"webmidi/input_map.html#map"},{"doc":"webmidi/input_map","title":"size","content":"pub fn size(input_map: MidiInputMap, key key: String) -&gt; Int\n\nSynonyms:\nwebmidi/input_map.size\nwebmidi/input_map size","url":"webmidi/input_map.html#size"},{"doc":"webmidi/input_map","title":"webmidi/input_map","content":"","url":"webmidi/input_map.html"},{"doc":"webmidi/output","title":"Exception","content":"pub type Exception {\n  TypeError(message: String)\n  InvalidAccessError\n  InvalidStateError\n}\n\nTypeError(message: String)\n\n\nInvalidAccessError\n\n\nInvalidStateError\n\n\nSynonyms:\nwebmidi/output.Exception\nwebmidi/output Exception","url":"webmidi/output.html#Exception"},{"doc":"webmidi/output","title":"clear","content":"pub fn clear(output: MidiOutput) -&gt; a\n\nSynonyms:\nwebmidi/output.clear\nwebmidi/output clear","url":"webmidi/output.html#clear"},{"doc":"webmidi/output","title":"closed","content":"pub fn closed(port: MidiOutput) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/output.closed\nwebmidi/output closed","url":"webmidi/output.html#closed"},{"doc":"webmidi/output","title":"connection","content":"pub fn connection(port: MidiOutput) -&gt; Connection\n\nSynonyms:\nwebmidi/output.connection\nwebmidi/output connection","url":"webmidi/output.html#connection"},{"doc":"webmidi/output","title":"id","content":"pub fn id(port: MidiOutput) -&gt; String\n\nSynonyms:\nwebmidi/output.id\nwebmidi/output id","url":"webmidi/output.html#id"},{"doc":"webmidi/output","title":"manufacturer","content":"pub fn manufacturer(port: MidiOutput) -&gt; String\n\nSynonyms:\nwebmidi/output.manufacturer\nwebmidi/output manufacturer","url":"webmidi/output.html#manufacturer"},{"doc":"webmidi/output","title":"name","content":"pub fn name(port: MidiOutput) -&gt; String\n\nSynonyms:\nwebmidi/output.name\nwebmidi/output name","url":"webmidi/output.html#name"},{"doc":"webmidi/output","title":"on_state_change","content":"pub fn on_state_change(\n  port: MidiOutput,\n  func: fn(ConnectionEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nwebmidi/output.on_state_change\nwebmidi/output on_state_change","url":"webmidi/output.html#on_state_change"},{"doc":"webmidi/output","title":"open","content":"pub fn open(port: MidiOutput) -&gt; Promise(Nil)\n\nSynonyms:\nwebmidi/output.open\nwebmidi/output open","url":"webmidi/output.html#open"},{"doc":"webmidi/output","title":"send","content":"pub fn send(\n  output: MidiOutput,\n  data: List(Int),\n) -&gt; Result(Nil, Exception)\n\nSynonyms:\nwebmidi/output.send\nwebmidi/output send","url":"webmidi/output.html#send"},{"doc":"webmidi/output","title":"state","content":"pub fn state(port: MidiOutput) -&gt; State\n\nSynonyms:\nwebmidi/output.state\nwebmidi/output state","url":"webmidi/output.html#state"},{"doc":"webmidi/output","title":"type_","content":"pub fn type_(port: MidiOutput) -&gt; Type\n\nSynonyms:\nwebmidi/output.type_\nwebmidi/output type_","url":"webmidi/output.html#type_"},{"doc":"webmidi/output","title":"version","content":"pub fn version(port: MidiOutput) -&gt; String\n\nSynonyms:\nwebmidi/output.version\nwebmidi/output version","url":"webmidi/output.html#version"},{"doc":"webmidi/output","title":"webmidi/output","content":"","url":"webmidi/output.html"},{"doc":"webmidi/output_map","title":"get","content":"pub fn get(\n  output_map: MidiOutputMap,\n  key key: String,\n) -&gt; Result(MidiOutput, Nil)\n\nSynonyms:\nwebmidi/output_map.get\nwebmidi/output_map get","url":"webmidi/output_map.html#get"},{"doc":"webmidi/output_map","title":"has","content":"pub fn has(output_map: MidiOutputMap, key key: String) -&gt; Bool\n\nSynonyms:\nwebmidi/output_map.has\nwebmidi/output_map has","url":"webmidi/output_map.html#has"},{"doc":"webmidi/output_map","title":"map","content":"pub fn map(\n  output_map: MidiOutputMap,\n  with fun: fn(String, MidiOutput) -&gt; a,\n) -&gt; a\n\nSynonyms:\nwebmidi/output_map.map\nwebmidi/output_map map","url":"webmidi/output_map.html#map"},{"doc":"webmidi/output_map","title":"size","content":"pub fn size(output_map: MidiOutputMap, key key: String) -&gt; Int\n\nSynonyms:\nwebmidi/output_map.size\nwebmidi/output_map size","url":"webmidi/output_map.html#size"},{"doc":"webmidi/output_map","title":"webmidi/output_map","content":"","url":"webmidi/output_map.html"}]);